#!/usr/bin/perl

if(@ARGV<2) { print "usage: $0 iNIR_file iEUMA_file > output.iFVKM\n"; exit; }
my ($iNIR_file,$iEUMA_file) = @ARGV;

open IN, $iNIR_file or die "Can't open iNIR_file $sample_iNIR_file\n";
<IN>;  # skip header
while(<IN>){
  chomp;
  split/\t/;
  $gene = $_[0]."\t".$_[1];
  $RNAseq{$gene}=$_[2];
}
close IN;

open IN, $iEUMA_file or die "Can't open iEUMA file $iEUMA_file\n";
while(<IN>){
  chomp;
  split/\t/;
  $gene = $_[0]."\t".$_[1];
  $iEUMA{$gene}=$_[2];
}
close IN;


print "gene\tisoform\tiFVK\tread.count\tiEUMA(bp)\n";
for my $gene (sort keys %iEUMA){
 next if $iEUMA{$gene} ==0;
 if(!exists $RNAseq{$gene}){ $RNAseq{$gene} = 0; }
 my $iFVKM = $RNAseq{$gene} / $iEUMA{$gene} * 1000;
 print "$gene\t$iFVKM\t$RNAseq{$gene}\t$iEUMA{$gene}\n";
}



